/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2203 from the
 * contents of OpenSSL.xs. Do not edit this file, edit OpenSSL.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "OpenSSL.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <openssl/opensslv.h>
#include <openssl/opensslconf.h>

#include <openssl/asn1.h>
#include <openssl/x509.h>
#include <openssl/x509v3.h>
#include <openssl/rand.h>

static char *prqp_exts[] = {
        /* PRQP extended key usage - id-kp-PRQPSigning ::= { id-kp 10 }*/
        "1.3.6.1.5.5.7.3.11", "prqpSigning", "PRQP Signing",
        /* PRQP PKIX identifier - id-prqp ::= { id-pkix 23 } */
        "1.3.6.1.5.5.7.23", "PRQP", "PKI Resource Query Protocol",
        /* PRQP PKIX - PTA identifier - { id-prqp 1 } */
        "1.3.6.1.5.5.7.23.1", "PTA", "PRQP Trusted Authority",
        /* PRQP AD id-ad-prqp ::= { id-ad   12 } */
        "1.3.6.1.5.5.7.48.12", "prqp", "PRQP Service",
        /* End of the List */
        NULL, NULL, NULL
};

static char *prqp_exts_services[] = {
        "1.3.6.1.5.5.7.48.12.0", "rqa", "PRQP RQA Server",
        "1.3.6.1.5.5.7.48.12.1", "ocspServer", "OCSP Server",
        "1.3.6.1.5.5.7.48.12.2", "subjectCert", "Subject Certificate Retieval URI",
        "1.3.6.1.5.5.7.48.12.3", "issuerCert", "Issuer's Certificate Retieval URI",
        "1.3.6.1.5.5.7.48.12.4", "timeStamping", "TimeStamping Service",
        /* PKIX - not yet defined */
        "1.3.6.1.5.5.7.48.12.5", "scvp", "SCVP Service",
        "1.3.6.1.5.5.7.48.12.6", "crlDistribution", "Latest CRL URI",
        "1.3.6.1.5.5.7.48.12.7", "certRepository", "CMS Certificate Repository",
        "1.3.6.1.5.5.7.48.12.8", "crlRepository", "CMS CRL Repository",
        "1.3.6.1.5.5.7.48.12.9", "crossCertRepository", "CMS Cross Certificate Repository",
        /* Gateways */
        "1.3.6.1.5.5.7.48.12.10", "cmcGateway", "CMC Gateway",
        "1.3.6.1.5.5.7.48.12.11", "scepGateway", "SCEP Gateway",
        "1.3.6.1.5.5.7.48.12.12", "htmlGateway", "HTML Gateway",
        "1.3.6.1.5.5.7.48.12.13", "xkmsGateway", "XKMS Gateway",
        /* Certificate Policies */
        "1.3.6.1.5.5.7.48.12.20", "certPolicy", "Certificate Policy (CP) URL",
        "1.3.6.1.5.5.7.48.12.21", "certPracticeStatement", "Certificate Practices Statement (CPS) URL",
        "1.3.6.1.5.5.7.48.12.22", "endorsedTA", "CMS Endorsed Trust Anchors",
        /* Level of Assurance (LOA) */
        "1.3.6.1.5.5.7.48.12.25", "loaPolicy", "LOA Policy URL",
        "1.3.6.1.5.5.7.48.12.26", "certLOALevel", "Certificate LOA Modifier URL",
        /* HTTP (Browsers) based services */
        "1.3.6.1.5.5.7.48.12.30", "htmlRequest", "HTML Certificate Request Service URL",
        "1.3.6.1.5.5.7.48.12.31", "htmlRevoke", "HTML Based Certificate Revocation Service URL",
        "1.3.6.1.5.5.7.48.12.32", "htmlRenew", "HTML Certificate Renewal Service URL",
        "1.3.6.1.5.5.7.48.12.33", "htmlSuspend", "HTML Certificate Suspension Service",
        /* Grid Specific Services */
        "1.3.6.1.5.5.7.48.12.50", "gridAccreditationBody", "CA Accreditation Bodies",
        "1.3.6.1.5.5.7.48.12.51", "gridAccreditationPolicy", "CA Accreditation Policy Document(s) URL",
        "1.3.6.1.5.5.7.48.12.52", "gridAccreditationStatus", "CA Accreditation Status Document(s) URL",
        "1.3.6.1.5.5.7.48.12.53", "gridDistributionUpdate", "Grid Distribution Package(s) URL",
        "1.3.6.1.5.5.7.48.12.54", "gridAccreditedCACerts", "Certificates of Currently Accredited CAs",
        /* Trust Anchors Publishing */
        "1.3.6.1.5.5.7.48.71", "apexTampUpdate", "APEX Trust Anchors Update URL",
        "1.3.6.1.5.5.7.48.70", "tampUpdate", "Trust Anchors Update URL",
        /* CA Incident report URL */
        "1.3.6.1.5.5.7.48.90", "caIncidentReport", "CA Incident Report URL",
        /* Private Services */
        "1.3.6.1.5.5.7.48.12.100", "private", "Private Service",
        NULL, NULL, NULL
        };

#define SCEP_CONF_LIST_SIZE     8

#define TRANS_ID_SIZE                           16

typedef struct scep_oid_st {
        int  attr_type;
        char *oid_s;
        char *descr;
        char *long_descr;
        int  nid;
} SCEP_CONF_ATTRIBUTE;

/* These should be in the same order than the SCEP_ATTRIBUTE_list in scep_attrs.c */
typedef enum {
        SCEP_ATTRIBUTE_MESSAGE_TYPE             = 0,
        SCEP_ATTRIBUTE_PKI_STATUS,
        SCEP_ATTRIBUTE_FAIL_INFO,
        SCEP_ATTRIBUTE_SENDER_NONCE,
        SCEP_ATTRIBUTE_RECIPIENT_NONCE,
        SCEP_ATTRIBUTE_TRANS_ID,
        SCEP_ATTRIBUTE_EXTENSION_REQ,
        SCEP_ATTRIBUTE_PROXY_AUTH
} SCEP_ATTRIBUTE_TYPE;

static SCEP_CONF_ATTRIBUTE SCEP_ATTRIBUTE_list [SCEP_CONF_LIST_SIZE] = {
        { SCEP_ATTRIBUTE_MESSAGE_TYPE, "2.16.840.1.113733.1.9.2",
                        "scepMessageType", "SCEP Message Type", -1 },
        { SCEP_ATTRIBUTE_PKI_STATUS, "2.16.840.1.113733.1.9.3",
                        "pkiStatus", "Status", -1 },
        { SCEP_ATTRIBUTE_FAIL_INFO, "2.16.840.1.113733.1.9.4",
                        "failInfo", "Failure Info", -1 },
        { SCEP_ATTRIBUTE_SENDER_NONCE, "2.16.840.1.113733.1.9.5",
                        "senderNonce", "Sender Nonce", -1 },
        { SCEP_ATTRIBUTE_RECIPIENT_NONCE, "2.16.840.1.113733.1.9.6",
                        "recipientNonce", "Recipient Nonce", -1 },
        { SCEP_ATTRIBUTE_TRANS_ID, "2.16.840.1.113733.1.9.7",
                        "transId", "Transaction Identifier", -1 },
        { SCEP_ATTRIBUTE_EXTENSION_REQ, "2.16.840.1.113733.1.9.8",
                        "extensionReq", "Extension Request", -1 },
        { SCEP_ATTRIBUTE_PROXY_AUTH, "1.3.6.1.4.1.4263.5.5",
                        "proxyAuth", "Proxy Authenticator", -1 },
};

#if OPENSSL_VERSION_NUMBER < 0x00908000L
#define OPENSSL_NO_EC
#endif

#ifndef OPENSSL_NO_EC
#include <openssl/ec.h>
#endif

#include "const-c.inc"

#if OPENSSL_VERSION_NUMBER >= 0x10000000L
typedef _STACK STACK;
#endif

/* Standard trick to have a C pointer as a Perl object, see the typemap */
typedef X509          * OpenCA_OpenSSL_X509;
typedef X509_CRL      * OpenCA_OpenSSL_CRL;
typedef NETSCAPE_SPKI * OpenCA_OpenSSL_SPKAC;
typedef X509_REQ      * OpenCA_OpenSSL_PKCS10;

#line 146 "OpenSSL.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 198 "OpenSSL.c"

/* INCLUDE:  Including 'const-xs.inc' from 'OpenSSL.xs' */


XS(XS_OpenCA__OpenSSL_constant); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL_constant)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv;
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 227 "OpenSSL.c"
	SV *	sv = ST(0);
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid OpenCA::OpenSSL::Fast macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined OpenCA::OpenSSL::Fast macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing OpenCA::OpenSSL::Fast macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 304 "OpenSSL.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'OpenSSL.xs' from 'const-xs.inc' */


XS(XS_OpenCA__OpenSSL__X509__new_from_der); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509__new_from_der)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
#line 146 "OpenSSL.xs"
	unsigned char * dercert;
	SSize_t certlen;
#line 328 "OpenSSL.c"
	OpenCA_OpenSSL_X509	RETVAL;
	SV *	sv = ST(0);
#line 149 "OpenSSL.xs"
	dercert = SvPV(sv, certlen);
	RETVAL = d2i_X509(NULL,&dercert,certlen);
#line 334 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::X509",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509__new_from_pem); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509__new_from_pem)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
#line 157 "OpenSSL.xs"
	unsigned char * pemcert;
	unsigned char * dercert;
	SSize_t certlen, inlen;
	char inbuf[512];
	BIO *bio_in, *bio_out, *b64;
#line 360 "OpenSSL.c"
	OpenCA_OpenSSL_X509	RETVAL;
	SV *	sv = ST(0);
#line 163 "OpenSSL.xs"
	pemcert = SvPV(sv, certlen);
	bio_in  = BIO_new(BIO_s_mem());
	bio_out = BIO_new(BIO_s_mem());
	b64     = BIO_new(BIO_f_base64());

	/* load encoded data into bio_in */
	BIO_write(bio_in, pemcert+27, certlen-27-25);

	/* set EOF for memory bio */
	BIO_set_mem_eof_return(bio_in, 0);

	/* decode data from one bio into another one */
	BIO_push(b64, bio_in);
        while((inlen = BIO_read(b64, inbuf, 512)) > 0)
		BIO_write(bio_out, inbuf, inlen);

	/* create dercert */
	certlen = BIO_get_mem_data(bio_out, &dercert);

	/* create cert */
	RETVAL = d2i_X509(NULL,&dercert,certlen);
	BIO_free_all(bio_in);
	BIO_free_all(bio_out);
#line 387 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::X509",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_init_oids); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_init_oids)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "void");
    {
#line 192 "OpenSSL.xs"
	int i, ret;
        int nid = NID_undef;
        SCEP_CONF_ATTRIBUTE *curr_oid = NULL;
#line 411 "OpenSSL.c"
	int	RETVAL;
	dXSTARG;
#line 196 "OpenSSL.xs"
        i = 0;
        while( prqp_exts[i] && prqp_exts[i+1] ) {
        	if((ret = OBJ_create(prqp_exts[i], prqp_exts[i+1],
        				prqp_exts[i+2])) == NID_undef) {
        		// return 0;
        	}
        	i = i+3;
        }

        i = 0;
        while( prqp_exts_services[i] && prqp_exts_services[i+1] ) {
        	if((ret = OBJ_create(prqp_exts_services[i],
        		prqp_exts_services[i+1], prqp_exts_services[i+2]))
        							== NID_undef) {
        		// return 0;
        	}
        	i = i+3;
        };

        i = 0;
        while( i < SCEP_CONF_LIST_SIZE ) {
                curr_oid = &SCEP_ATTRIBUTE_list[i];
                if(( nid = OBJ_create(curr_oid->oid_s, curr_oid->descr,
                         	curr_oid->long_descr)) == NID_undef) {
                        // return 0;
                }

                curr_oid->nid = nid;
                i++;
        }

	RETVAL=1;
#line 447 "OpenSSL.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_serial); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_serial)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 235 "OpenSSL.xs"
	char * stringval;
#line 468 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 237 "OpenSSL.xs"
	stringval = i2s_ASN1_INTEGER(NULL,X509_get_serialNumber(cert));
	RETVAL = stringval;
#line 481 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_hex_serial); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_hex_serial)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 246 "OpenSSL.xs"
	ASN1_INTEGER *val;
	long i, idx;
	char *retVal;
#line 504 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 250 "OpenSSL.xs"
	if((val = X509_get_serialNumber(cert)) != NULL ) {
		retVal = malloc ( 2 + (val->length * 3) + 1 );
		idx = 2;
		sprintf(retVal, "0x");
		for (i=0; i < val->length; i++) {
			sprintf( &retVal[idx], "%02x%c", val->data[i], 
				((i+1 == val->length)?'\x0':':'));
			idx += 3;
		}
		RETVAL=retVal;
	} else {
		RETVAL=strdup("0x0");
	}
#line 528 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_subject); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_subject)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 270 "OpenSSL.xs"
	BIO *out;
	unsigned char *subject, *result;
	int n;
#line 551 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 274 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, X509_get_subject_name(cert), 0, XN_FLAG_RFC2253&(~ASN1_STRFLGS_ESC_MSB));
	n = BIO_get_mem_data(out, &subject);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, subject, n);
	RETVAL = result;
	BIO_free(out);
#line 570 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_openssl_subject); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_openssl_subject)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 289 "OpenSSL.xs"
	BIO *out;
	unsigned char *subject, *result;
	int n;
#line 593 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 293 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, X509_get_subject_name(cert), 0, 0);
	n = BIO_get_mem_data(out, &subject);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, subject, n);
	RETVAL = result;
	BIO_free(out);
#line 612 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_issuer); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_issuer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 308 "OpenSSL.xs"
	BIO *out;
	unsigned char *issuer, *result;
	int n;
#line 635 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 312 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, X509_get_issuer_name(cert), 0, XN_FLAG_RFC2253&(~ASN1_STRFLGS_ESC_MSB));
	n = BIO_get_mem_data(out, &issuer);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, issuer, n);
	RETVAL = result;
	BIO_free(out);
#line 654 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_notBefore); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_notBefore)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 327 "OpenSSL.xs"
	unsigned char *not, *result;
	int n;
	BIO *out;
#line 677 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 331 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ASN1_TIME_print(out, X509_get_notBefore(cert));
	n = BIO_get_mem_data(out, &not);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, not, n);
	RETVAL = result;
	BIO_free(out);
#line 696 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_notAfter); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_notAfter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 346 "OpenSSL.xs"
	unsigned char *not, *result;
	int n;
	BIO *out;
#line 719 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 350 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ASN1_TIME_print(out, X509_get_notAfter(cert));
	n = BIO_get_mem_data(out, &not);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, not, n);
	RETVAL = result;
	BIO_free(out);
#line 738 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_alias); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_alias)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 365 "OpenSSL.xs"
#line 758 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 366 "OpenSSL.xs"
	RETVAL = X509_alias_get0(cert, NULL);
#line 770 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_fingerprint); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_fingerprint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "cert, digest_name=\"sha1\"");
    {
	OpenCA_OpenSSL_X509	cert;
	char *	digest_name;
#line 375 "OpenSSL.xs"
	BIO *out;
	int j;
	unsigned int n;
	const EVP_MD *digest;
	unsigned char * fingerprint, *result;
	unsigned char md[EVP_MAX_MD_SIZE];
	unsigned char str[3];
#line 798 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");

	if (items < 2)
	    digest_name = "sha1";
	else {
	    digest_name = (char *)SvPV_nolen(ST(1));
	}
#line 383 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	if (!strcmp ("sha1", digest_name))
		digest = EVP_sha1();
	else
		digest = EVP_md5();
	if (X509_digest(cert,digest,md,&n))
	{
		/* BIO_printf(out, "%s:", OBJ_nid2sn(EVP_MD_type(digest))); */
		for (j=0; j<(int)n; j++) {
			BIO_printf (out, "%02x",md[j]);
			/* if (j+1 != (int)n) BIO_printf(out,":"); */
		}
	}
	n = BIO_get_mem_data(out, &fingerprint);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, fingerprint, n);
	RETVAL = result;
	BIO_free(out);
#line 834 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_subject_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_subject_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 409 "OpenSSL.xs"
#line 854 "OpenSSL.c"
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 410 "OpenSSL.xs"
	RETVAL = X509_subject_name_hash(cert);
#line 866 "OpenSSL.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_emailaddress); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_emailaddress)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 418 "OpenSSL.xs"
	int j, n;
        STACK *emlst;
	BIO *out;
	unsigned char *emails, *result;
#line 890 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 423 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	emlst = X509_get1_email(cert);
	for (j = 0; j < sk_num(emlst); j++)
	{
		BIO_printf(out, "%s", sk_value(emlst, j));
		if (j+1 != (int)sk_num(emlst))
			BIO_printf(out,"\n");
	}
	X509_email_free(emlst);
	n = BIO_get_mem_data(out, &emails);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, emails, n);
	RETVAL = result;
	BIO_free(out);
#line 916 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 445 "OpenSSL.xs"
	BIO *out;
	unsigned char *version, *result;
	unsigned char buf[1024];
	long l;
#line 940 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 450 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	l = X509_get_version(cert);
	BIO_printf (out,"%lu (0x%lx)",l+1,l);
	l = BIO_get_mem_data(out, &version);
	result = (char *) malloc (l+1);
	result[l] = '\0';
	memcpy (result, version, l);
	RETVAL = strdup (result);
	BIO_free(out);
#line 960 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_pubkey_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_pubkey_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 466 "OpenSSL.xs"
	BIO *out;
	unsigned char *pubkey, *result;
	X509_CINF *ci;
	int n;
#line 984 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 471 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ci = cert->cert_info;
	i2a_ASN1_OBJECT(out, ci->key->algor->algorithm);
	n = BIO_get_mem_data(out, &pubkey);
	result = (char *) malloc (n+1);
	result[n] = '\0';
	memcpy (result, pubkey, n);
	RETVAL = strdup (result);
	BIO_free(out);
#line 1004 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_pubkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 487 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char *pubkey, *result;
	int n;
#line 1028 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 492 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_get_pubkey(cert);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA)
			RSA_print(out,pkey->pkey.rsa,0);
#ifndef OPENSSL_NO_DSA
		else if (pkey->type == EVP_PKEY_DSA)
			DSA_print(out,pkey->pkey.dsa,0);
#endif
#ifndef OPENSSL_NO_EC
		else if (pkey->type == EVP_PKEY_EC)
			EC_KEY_print(out, pkey->pkey.ec,0);
#endif
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	result = (char *) malloc (n+1);
	result[n] = '\0';
	memcpy (result, pubkey, n);
	RETVAL = strdup (result);
	BIO_free(out);
#line 1061 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_keysize); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_keysize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 521 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char * pubkey, *result;
	int n;
	BIGNUM *priv_key;
#ifndef OPENSSL_NO_DSA
	DSA *dsa;
#endif
#ifndef OPENSSL_NO_EC
	EC_KEY *ec;
#endif
	RSA *rsa;
#line 1093 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 534 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_get_pubkey(cert);
	if (pkey != NULL) {
		if (pkey->type == EVP_PKEY_RSA) {
			rsa = EVP_PKEY_get1_RSA(pkey);
			if( rsa ) {
				BIO_printf(out,"%d", BN_num_bits(rsa->n));
			} else {
				BIO_printf(out,"%d", 0);
			}
		}
#ifndef OPENSSL_NO_DSA
		else if (pkey->type == EVP_PKEY_DSA) {
			dsa = EVP_PKEY_get1_DSA(pkey);
			if( dsa ) {
				BIO_printf(out,"%d", BN_num_bits(dsa->pub_key));
			} else {
				BIO_printf(out,"%d", 0);
			}
		}
#endif
#ifndef OPENSSL_NO_EC
		else if (pkey->type == EVP_PKEY_EC) {
			ec = EVP_PKEY_get1_EC_KEY(pkey);
			if( ec ) {
				BIO_printf(out, "%d", EVP_PKEY_bits(pkey));
			} else {
				BIO_printf(out,"%d", -3);
			}
		}
#endif
		else {
			/* Unknown Type! */
			BIO_printf(out,"%d", 0);
		}

		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, pubkey, n);
	RETVAL = strdup (result);
	BIO_free(out);
#line 1148 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_modulus); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_modulus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 585 "OpenSSL.xs"
	unsigned char * modulus, *result;
	BIO *out;
	EVP_PKEY *pkey;
	int n;
#line 1172 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 590 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_get_pubkey(cert);

	if (pkey == NULL) {
		BIO_printf(out,"");
	}
	else if (pkey->type == EVP_PKEY_RSA) {
		BN_print(out,pkey->pkey.rsa->n);
	}
#ifndef OPENSSL_NO_DSA
	else if (pkey->type == EVP_PKEY_DSA) {
		BN_print(out,pkey->pkey.dsa->pub_key);
	}
#endif
#ifndef OPENSSL_NO_EC
	else if (pkey->type == EVP_PKEY_EC) {
		EC_KEY *ec;
		BIGNUM  *pub_key=NULL;
        	BN_CTX  *ctx=NULL;

	        const EC_GROUP *group;
	        const EC_POINT *public_key;

		ec = EVP_PKEY_get1_EC_KEY(pkey);
		if (ec == NULL || (group = EC_KEY_get0_group(ec)) == NULL) {
			// Nothing happens here!
                } else {

        		public_key = EC_KEY_get0_public_key(ec);
        		if ((pub_key = EC_POINT_point2bn(group, public_key,
                		EC_KEY_get_conv_form(ec), NULL, ctx)) != NULL) {

				BN_print(out, pub_key);
                	}
		}
	}
#endif
	else
		BIO_printf(out,"");

	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &modulus);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, modulus, n);
	RETVAL = result;
	BIO_free(out);
#line 1230 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_exponent); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_exponent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 644 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char *exponent, *result;
	int n;
#line 1254 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 649 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_get_pubkey(cert);
	if (pkey == NULL) {
		BIO_printf(out,"");
	} else if (pkey->type == EVP_PKEY_RSA) {
		BN_print(out,pkey->pkey.rsa->e);
	} 
#ifndef OPENSSL_NO_DSA
	else if (pkey->type == EVP_PKEY_DSA) {
		BN_print(out,pkey->pkey.dsa->pub_key);
	}
#endif
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &exponent);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, exponent, n);
	RETVAL = result;
	BIO_free(out);
#line 1286 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_extensions); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_extensions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 677 "OpenSSL.xs"
	BIO *out;
	unsigned char *ext, *result;
	X509_CINF *ci;
	int n;
#line 1310 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 682 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ci = cert->cert_info;
	result = NULL;
	// there is a bug in X509V3_extensions_print
	// the causes the function to fail if title == NULL and indent == 0
	X509V3_extensions_print(out, NULL, ci->extensions, 0, 4);
	n = BIO_get_mem_data(out, &ext);
	if (n)
	{
		result = (char *) malloc (n+1);
		result [n] = '\0';
		memcpy (result, ext, n);
	}
	RETVAL = result;
	BIO_free(out);
#line 1336 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_signature_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_signature_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 704 "OpenSSL.xs"
	BIO *out;
	unsigned char *sig, *result;
	X509_CINF *ci;
	int n;
#line 1360 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 709 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ci = cert->cert_info;
	i2a_ASN1_OBJECT(out, ci->signature->algorithm);
	n = BIO_get_mem_data(out, &sig);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, sig, n);
	RETVAL = result;
	BIO_free(out);
#line 1380 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cert");
    {
	OpenCA_OpenSSL_X509	cert;
#line 725 "OpenSSL.xs"
	BIO *out;
	unsigned char *sig, *result;
	int n,i;
	unsigned char *s;
#line 1404 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 730 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	n=cert->signature->length;
	s=cert->signature->data;
	for (i=0; i<n; i++)
	{
		if ( ((i%18) == 0) && (i!=0) ) BIO_printf(out,"\n");
		BIO_printf(out,"%02x%s",s[i], (((i+1)%18) == 0)?"":":");
	}
	n = BIO_get_mem_data(out, &sig);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, sig, n);
	RETVAL = result;
	BIO_free(out);
#line 1429 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL__new_from_der); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL__new_from_der)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
#line 753 "OpenSSL.xs"
	unsigned char * dercrl;
	SSize_t crllen;
#line 1450 "OpenSSL.c"
	OpenCA_OpenSSL_CRL	RETVAL;
	SV *	sv = ST(0);
#line 756 "OpenSSL.xs"
	dercrl = SvPV(sv, crllen);
	RETVAL = d2i_X509_CRL(NULL,&dercrl,crllen);
#line 1456 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::CRL",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL__new_from_pem); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL__new_from_pem)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
#line 764 "OpenSSL.xs"
	unsigned char * pemcrl;
	unsigned char * dercrl;
	SSize_t crllen, inlen;
	char inbuf[512];
	BIO *bio_in, *bio_out, *b64;
	X509_CRL *crl;
#line 1483 "OpenSSL.c"
	OpenCA_OpenSSL_CRL	RETVAL;
	SV *	sv = ST(0);
#line 771 "OpenSSL.xs"
	pemcrl = SvPV(sv, crllen);
	bio_in  = BIO_new(BIO_s_mem());
	bio_out = BIO_new(BIO_s_mem());
	b64     = BIO_new(BIO_f_base64());

	/* load encoded data into bio_in */
	BIO_write(bio_in, pemcrl+25, crllen-25-23);

	/* set EOF for memory bio */
	BIO_set_mem_eof_return(bio_in, 0);

	/* decode data from one bio into another one */
	BIO_push(b64, bio_in);
        while((inlen = BIO_read(b64, inbuf, 512)) > 0)
		BIO_write(bio_out, inbuf, inlen);

	/* create dercert */
	crllen = BIO_get_mem_data(bio_out, &dercrl);

	/* create cert */
	crl = d2i_X509_CRL(NULL,&dercrl,crllen);
	RETVAL = crl;
	BIO_free_all(bio_in);
	BIO_free_all(bio_out);
#line 1511 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::CRL",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 802 "OpenSSL.xs"
	BIO *out;
	unsigned char *version, *result;
	unsigned char buf[1024];
	long l;
#line 1537 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 807 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	l = X509_CRL_get_version(crl);
	BIO_printf (out,"%lu (0x%lx)",l+1,l);
	l = BIO_get_mem_data(out, &version);
	result = (char *) malloc (l+1);
	result[l] = '\0';
	memcpy (result, version, l);
	RETVAL = strdup (result);
	BIO_free(out);
#line 1557 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_issuer); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_issuer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 823 "OpenSSL.xs"
	BIO *out;
	unsigned char *issuer, *result;
	int n;
#line 1580 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 827 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, X509_CRL_get_issuer(crl), 0, XN_FLAG_RFC2253&(~ASN1_STRFLGS_ESC_MSB));
	n = BIO_get_mem_data(out, &issuer);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, issuer, n);
	RETVAL = result;
	BIO_free(out);
#line 1599 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_issuer_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_issuer_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 842 "OpenSSL.xs"
#line 1619 "OpenSSL.c"
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 843 "OpenSSL.xs"
	RETVAL = X509_NAME_hash(X509_CRL_get_issuer(crl));
#line 1631 "OpenSSL.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_lastUpdate); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_lastUpdate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 851 "OpenSSL.xs"
	unsigned char *not, *result;
	int n;
	BIO *out;
#line 1654 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 855 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ASN1_TIME_print(out, X509_CRL_get_lastUpdate(crl));
	n = BIO_get_mem_data(out, &not);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, not, n);
	RETVAL = result;
	BIO_free(out);
#line 1673 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_nextUpdate); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_nextUpdate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 870 "OpenSSL.xs"
	unsigned char *not, *result;
	int n;
	BIO *out;
#line 1696 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 874 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ASN1_TIME_print(out, X509_CRL_get_nextUpdate(crl));
	n = BIO_get_mem_data(out, &not);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, not, n);
	RETVAL = result;
	BIO_free(out);
#line 1715 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_fingerprint); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_fingerprint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "crl, digest_name=\"sha1\"");
    {
	OpenCA_OpenSSL_CRL	crl;
	char *	digest_name;
#line 890 "OpenSSL.xs"
	BIO *out;
	int j;
	unsigned int n;
	const EVP_MD *digest;
	unsigned char * fingerprint, *result;
	unsigned char md[EVP_MAX_MD_SIZE];
	unsigned char str[3];
#line 1743 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");

	if (items < 2)
	    digest_name = "sha1";
	else {
	    digest_name = (char *)SvPV_nolen(ST(1));
	}
#line 898 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	if (!strcmp ("sha1", digest_name))
		digest = EVP_sha1();
	else
		digest = EVP_md5();
	if (X509_CRL_digest(crl,digest,md,&n))
	{
		BIO_printf(out, "%s:", OBJ_nid2sn(EVP_MD_type(digest)));
		for (j=0; j<(int)n; j++)
		{
			BIO_printf (out, "%02X",md[j]);
			if (j+1 != (int)n) BIO_printf(out,":");
		}
	}
	n = BIO_get_mem_data(out, &fingerprint);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, fingerprint, n);
	RETVAL = result;
	BIO_free(out);
#line 1780 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_signature_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_signature_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 925 "OpenSSL.xs"
	BIO *out;
	unsigned char *sig, *result;
	X509_CINF *ci;
	int n;
#line 1804 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 930 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	i2a_ASN1_OBJECT(out, crl->sig_alg->algorithm);
	n = BIO_get_mem_data(out, &sig);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, sig, n);
	RETVAL = result;
	BIO_free(out);
#line 1823 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 945 "OpenSSL.xs"
	BIO *out;
	unsigned char *sig, *result;
	int n,i;
	unsigned char *s;
#line 1847 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 950 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	n=crl->signature->length;
	s=crl->signature->data;
	for (i=0; i<n; i++)
	{
		if ( ((i%18) == 0) && (i!=0) ) BIO_printf(out,"\n");
		BIO_printf(out,"%02x%s",s[i], (((i+1)%18) == 0)?"":":");
	}
	n = BIO_get_mem_data(out, &sig);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, sig, n);
	RETVAL = result;
	BIO_free(out);
#line 1872 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_extensions); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_extensions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 971 "OpenSSL.xs"
	BIO *out;
	unsigned char *ext, *result;
	int n;
#line 1895 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 975 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	result = NULL;
	// there is a bug in X509V3_extensions_print
	// the causes the function to fail if title == NULL and indent == 0
	X509V3_extensions_print(out, NULL, crl->crl->extensions, 0, 4);
	n = BIO_get_mem_data(out, &ext);
	if (n)
	{
		result = (char *) malloc (n+1);
		result [n] = '\0';
		memcpy (result, ext, n);
	}
	RETVAL = result;
	BIO_free(out);
#line 1920 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_serial); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_serial)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 996 "OpenSSL.xs"
	ASN1_INTEGER *aint;
#line 1941 "OpenSSL.c"
	long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 998 "OpenSSL.xs"
	RETVAL = -1;
	aint = X509_CRL_get_ext_d2i (crl, NID_crl_number, NULL, NULL);
	if (aint != NULL)
        {
	    RETVAL = ASN1_INTEGER_get (aint);
            ASN1_INTEGER_free(aint);
        }
#line 1959 "OpenSSL.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_revoked); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_revoked)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	OpenCA_OpenSSL_CRL	crl;
#line 1012 "OpenSSL.xs"
	BIO *out;
	unsigned char *ext, *result;
	int n,i;
	STACK_OF(X509_REVOKED) *rev;
	X509_REVOKED *r;
#line 1984 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 1018 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	result = NULL;
	// there is a bug in X509V3_extensions_print
	// the causes the function to fail if title == NULL and indent == 0

	rev = X509_CRL_get_REVOKED(crl);

	for(i = 0; i < sk_X509_REVOKED_num(rev); i++) {
		r = sk_X509_REVOKED_value(rev, i);
		i2a_ASN1_INTEGER(out,r->serialNumber);
		BIO_printf(out,"\n        ");
		ASN1_TIME_print(out,r->revocationDate);
		BIO_printf(out,"\n");
		X509V3_extensions_print(out, NULL,
			r->extensions, 0, 8);
	}
	n = BIO_get_mem_data(out, &ext);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, ext, n);
	RETVAL = result;
	BIO_free(out);
#line 2017 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC__new); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC__new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
#line 1049 "OpenSSL.xs"
	unsigned char * spkac;
	SSize_t len;
	BIO *bio;
	CONF *conf = NULL;
	int i;
	char *spkstr = NULL;
#line 2042 "OpenSSL.c"
	OpenCA_OpenSSL_SPKAC	RETVAL;
	SV *	sv = ST(0);
#line 1056 "OpenSSL.xs"
	spkac = SvPV(sv, len);

	bio  = BIO_new(BIO_s_mem());

	/* load encoded data into bio */
	BIO_write(bio, spkac, len);

        conf = NCONF_new(NULL);
        i = NCONF_load_bio(conf, bio, NULL);

        if(!i) {
		exit (100);
        }

        spkstr = NCONF_get_string(conf, "default", "SPKAC");

	/* RETVAL = NETSCAPE_SPKI_b64_decode(spkac, len); */
	RETVAL = NETSCAPE_SPKI_b64_decode(spkstr, -1);
#line 2064 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::SPKAC",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_pubkey_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_pubkey_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spkac");
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 1081 "OpenSSL.xs"
	BIO *out;
	unsigned char *pubkey, *result;
	X509_CINF *ci;
	int n;
#line 2090 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1086 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	i2a_ASN1_OBJECT(out, spkac->spkac->pubkey->algor->algorithm);
	n = BIO_get_mem_data(out, &pubkey);
	result = (char *) malloc (n+1);
	result[n] = '\0';
	memcpy (result, pubkey, n);
	RETVAL = strdup (result);
	BIO_free(out);
#line 2109 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_pubkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spkac");
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 1101 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char *pubkey, *result;
	int n;
#line 2133 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1106 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_PUBKEY_get(spkac->spkac->pubkey);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA)
			RSA_print(out,pkey->pkey.rsa,0);
		else if (pkey->type == EVP_PKEY_DSA)
			DSA_print(out,pkey->pkey.dsa,0);
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	result = (char *) malloc (n+1);
	result[n] = '\0';
	memcpy (result, pubkey, n);
	RETVAL = strdup (result);
	BIO_free(out);
#line 2160 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_keysize); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_keysize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spkac");
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 1129 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char * pubkey, *result;
	int n;
#line 2184 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1134 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_PUBKEY_get(spkac->spkac->pubkey);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA)
			BIO_printf(out,"%d", BN_num_bits(pkey->pkey.rsa->n));
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, pubkey, n);
	RETVAL = strdup (result);
	BIO_free(out);
#line 2209 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_modulus); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_modulus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spkac");
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 1155 "OpenSSL.xs"
	unsigned char * modulus, *result;
	BIO *out;
	EVP_PKEY *pkey;
	int n;
#line 2233 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1160 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_PUBKEY_get(spkac->spkac->pubkey);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->n);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &modulus);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, modulus, n);
	RETVAL = result;
	BIO_free(out);
#line 2261 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_exponent); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_exponent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spkac");
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 1184 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char *exponent, *result;
	int n;
#line 2285 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1189 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_PUBKEY_get(spkac->spkac->pubkey);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->e);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &exponent);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, exponent, n);
	RETVAL = result;
	BIO_free(out);
#line 2313 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_signature_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_signature_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spkac");
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 1213 "OpenSSL.xs"
	unsigned char *result;
#line 2334 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1215 "OpenSSL.xs"
	result = (char *) malloc (1);
	result [0] = '\0';
	RETVAL = result;
#line 2348 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "spkac");
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 1225 "OpenSSL.xs"
	unsigned char *result;
#line 2369 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1227 "OpenSSL.xs"
	result = (char *) malloc (1);
	result [0] = '\0';
	RETVAL = result;
#line 2383 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10__new_from_der); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10__new_from_der)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
#line 1239 "OpenSSL.xs"
	unsigned char * dercsr;
	SSize_t csrlen;
#line 2404 "OpenSSL.c"
	OpenCA_OpenSSL_PKCS10	RETVAL;
	SV *	sv = ST(0);
#line 1242 "OpenSSL.xs"
	dercsr = SvPV(sv, csrlen);
	RETVAL = d2i_X509_REQ(NULL,&dercsr,csrlen);
#line 2410 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::PKCS10",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10__new_from_pem); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10__new_from_pem)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
#line 1250 "OpenSSL.xs"
	unsigned char * pemcsr;
	unsigned char * dercsr;
	SSize_t csrlen, inlen;
	char inbuf[512];
	BIO *bio_in, *bio_out, *b64;
#line 2436 "OpenSSL.c"
	OpenCA_OpenSSL_PKCS10	RETVAL;
	SV *	sv = ST(0);
#line 1256 "OpenSSL.xs"
	pemcsr  = SvPV(sv, csrlen);
	bio_in  = BIO_new(BIO_s_mem());
	bio_out = BIO_new(BIO_s_mem());
	b64     = BIO_new(BIO_f_base64());

	/* load encoded data into bio_in */
	BIO_write(bio_in, pemcsr+36, csrlen-36-34);

	/* set EOF for memory bio */
	BIO_set_mem_eof_return(bio_in, 0);

	/* decode data from one bio into another one */
	BIO_push(b64, bio_in);
        while((inlen = BIO_read(b64, inbuf, 512)) > 0)
		BIO_write(bio_out, inbuf, inlen);

	/* create dercsr */
	csrlen = BIO_get_mem_data(bio_out, &dercsr);

	/* create csr */
	RETVAL = d2i_X509_REQ(NULL,&dercsr,csrlen);
	BIO_free_all(bio_in);
	BIO_free_all(bio_out);
#line 2463 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::PKCS10",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1288 "OpenSSL.xs"
	BIO *out;
	unsigned char *version, *result;
	unsigned char buf[1024];
	long l, i;
	const char *neg;
#line 2490 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1294 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());

	neg=(csr->req_info->version->type == V_ASN1_NEG_INTEGER)?"-":"";
	l=0;
	for (i=0; i<csr->req_info->version->length; i++)
		{ l<<=8; l+=csr->req_info->version->data[i]; }
	/* why we use l and not l+1 like for all other versions? */
	BIO_printf(out,"%s%lu (%s0x%lx)",neg,l,neg,l);
	l = BIO_get_mem_data(out, &version);
	result = (char *) malloc (l+1);
	result[l] = '\0';
	memcpy (result, version, l);
	RETVAL = strdup (result);
	BIO_free(out);
#line 2515 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_subject); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_subject)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1315 "OpenSSL.xs"
	BIO *out;
	unsigned char *subject, *result;
	int n;
#line 2538 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1319 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, csr->req_info->subject, 0, XN_FLAG_RFC2253&(~ASN1_STRFLGS_ESC_MSB));
	n = BIO_get_mem_data(out, &subject);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, subject, n);
	RETVAL = result;
	BIO_free(out);
#line 2557 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_subject_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_subject_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1334 "OpenSSL.xs"
#line 2577 "OpenSSL.c"
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1335 "OpenSSL.xs"
	RETVAL = X509_NAME_hash(csr->req_info->subject);
#line 2589 "OpenSSL.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_fingerprint); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_fingerprint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "csr, digest_name=\"sha1\"");
    {
	OpenCA_OpenSSL_PKCS10	csr;
	char *	digest_name;
#line 1344 "OpenSSL.xs"
	BIO *out;
	int j;
	unsigned int n;
	const EVP_MD *digest;
	unsigned char * fingerprint, *result;
	unsigned char md[EVP_MAX_MD_SIZE];
	unsigned char str[3];
#line 2617 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");

	if (items < 2)
	    digest_name = "sha1";
	else {
	    digest_name = (char *)SvPV_nolen(ST(1));
	}
#line 1352 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	if (!strcmp ("sha1", digest_name))
		digest = EVP_sha1();
	else
		digest = EVP_md5();
	if (X509_REQ_digest(csr,digest,md,&n))
	{
		BIO_printf(out, "%s:", OBJ_nid2sn(EVP_MD_type(digest)));
		for (j=0; j<(int)n; j++)
		{
			BIO_printf (out, "%02X",md[j]);
			if (j+1 != (int)n) BIO_printf(out,":");
		}
	}
	n = BIO_get_mem_data(out, &fingerprint);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, fingerprint, n);
	RETVAL = result;
	BIO_free(out);
#line 2654 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_emailaddress); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_emailaddress)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1379 "OpenSSL.xs"
	int j, n;
        STACK *emlst;
	BIO *out;
	unsigned char *emails, *result;
#line 2678 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1384 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	emlst = X509_REQ_get1_email(csr);
	for (j = 0; j < sk_num(emlst); j++)
	{
		BIO_printf(out, "%s", sk_value(emlst, j));
		if (j+1 != (int)sk_num(emlst))
			BIO_printf(out,"\n");
	}
	X509_email_free(emlst);
	n = BIO_get_mem_data(out, &emails);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, emails, n);
	RETVAL = result;
	BIO_free(out);
#line 2704 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_pubkey_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_pubkey_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1406 "OpenSSL.xs"
	BIO *out;
	unsigned char *pubkey, *result;
	X509_REQ_INFO *ri;
	int n;
#line 2728 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1411 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ri = csr->req_info;
	i2a_ASN1_OBJECT(out, ri->pubkey->algor->algorithm);
	n = BIO_get_mem_data(out, &pubkey);
	result = (char *) malloc (n+1);
	result[n] = '\0';
	memcpy (result, pubkey, n);
	RETVAL = strdup (result);
	BIO_free(out);
#line 2748 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_pubkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1427 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char *pubkey, *result;
	int n;
#line 2772 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1432 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_REQ_get_pubkey(csr);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA) {
			RSA_print(out,pkey->pkey.rsa,0);
		}
#ifndef OPENSSL_NO_DSA
		else if (pkey->type == EVP_PKEY_DSA) {
			DSA_print(out,pkey->pkey.dsa,0);
		}
#endif
#ifndef OPENSSL_NO_EC
		else if (pkey->type == EVP_PKEY_EC) {
			EC_KEY_print(out, pkey->pkey.ec,0);
		}
#endif
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	result = (char *) malloc (n+1);
	result[n] = '\0';
	memcpy (result, pubkey, n);
	RETVAL = strdup (result);
	BIO_free(out);
#line 2808 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_keysize); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_keysize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1464 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char * pubkey, *result;
	int n;
	BIGNUM *priv_key;
	RSA *rsa;
#ifndef OPENSSL_NO_DSA
	DSA *dsa;
#endif
#ifndef OPENSSL_NO_EC
	EC_KEY *ec;
#endif
#line 2840 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1477 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_REQ_get_pubkey(csr);
	if (pkey != NULL) {
		if (pkey->type == EVP_PKEY_RSA) {
			rsa = EVP_PKEY_get1_RSA(pkey);
			if( rsa ) {
				BIO_printf(out, "%d", EVP_PKEY_bits(pkey));
				/* BIO_printf(out,"%d",BN_num_bits(rsa->n));*/
			} else {
				BIO_printf(out,"%d", 0);
			}
			/* BIO_printf(out,"%d", BN_num_bits(pkey->pkey.rsa->n)); */
		}
#ifndef OPENSSL_NO_DSA
		else if (pkey->type == EVP_PKEY_DSA) {
			dsa = EVP_PKEY_get1_DSA(pkey);
			if( dsa ) {
				BIO_printf(out, "%d", EVP_PKEY_bits(pkey));
				/*
				BIO_printf(out,"%d", 
					BN_num_bits(dsa->pub_key) + 1);
				*/
			} else {
				BIO_printf(out,"%d", 0);
			}
		}
#endif
#ifndef OPENSSL_NO_EC
		else if (pkey->type == EVP_PKEY_EC) {
			ec = EVP_PKEY_get1_EC_KEY(pkey);
			if( ec ) {
				BIO_printf(out, "%d", EVP_PKEY_bits(pkey));
			} else {
				BIO_printf(out,"%d", -3);
			}
		}
#endif
		else {
			/* Unknown Type! */
			BIO_printf(out,"%d", -1);
		}
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, pubkey, n);
	RETVAL = strdup (result);
	BIO_free(out);
#line 2900 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_modulus); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_modulus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1533 "OpenSSL.xs"
	unsigned char * modulus, *result;
	BIO *out;
	EVP_PKEY *pkey;
	int n;
#line 2924 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1538 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_REQ_get_pubkey(csr);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->n);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &modulus);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, modulus, n);
	RETVAL = result;
	BIO_free(out);
#line 2952 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_exponent); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_exponent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1562 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char *exponent, *result;
	int n;
#line 2976 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1567 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_REQ_get_pubkey(csr);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->e);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &exponent);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, exponent, n);
	RETVAL = result;
	BIO_free(out);
#line 3004 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_extensions); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_extensions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1591 "OpenSSL.xs"
	BIO *out;
	unsigned char *ext, *result;
	int n;
#line 3027 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1595 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	result = NULL;
	// there is a bug in X509V3_extensions_print
	// the causes the function to fail if title == NULL and indent == 0
	X509V3_extensions_print(out, NULL, X509_REQ_get_extensions(csr), 0, 4);
	n = BIO_get_mem_data(out, &ext);
	if (n)
	{
		result = (char *) malloc (n+1);
		result [n] = '\0';
		memcpy (result, ext, n);
	}
	RETVAL = result;
	BIO_free(out);
#line 3052 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_attributes); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_attributes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1616 "OpenSSL.xs"
	BIO *out;
	unsigned char *ext, *result;
	STACK_OF(X509_ATTRIBUTE) *sk;
	int n,i;
#line 3076 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1621 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	result = NULL;
	sk=csr->req_info->attributes;
	for (i=0; i<sk_X509_ATTRIBUTE_num(sk); i++)
	{
		ASN1_TYPE *at;
		X509_ATTRIBUTE *a;
		ASN1_BIT_STRING *bs=NULL;
		ASN1_TYPE *t;
		int j,type=0,count=1,ii=0;

		a=sk_X509_ATTRIBUTE_value(sk,i);
		if(X509_REQ_extension_nid(OBJ_obj2nid(a->object)))
			continue;
		if ((j=i2a_ASN1_OBJECT(out,a->object)) > 0)
		{
			if (a->single)
			{
				t=a->value.single;
				type=t->type;
				bs=t->value.bit_string;
			}
			else
			{
				ii=0;
				count=sk_ASN1_TYPE_num(a->value.set);
get_next:
				at=sk_ASN1_TYPE_value(a->value.set,ii);
				type=at->type;
				bs=at->value.asn1_string;
			}
		}
		for (j=25-j; j>0; j--)
			BIO_write(out," ",1);
		BIO_puts(out,":");
		if (    (type == V_ASN1_PRINTABLESTRING) ||
			(type == V_ASN1_T61STRING) ||
			(type == V_ASN1_IA5STRING))
		{
			BIO_write(out,(char *)bs->data,bs->length);
			BIO_puts(out,"\n");
		}
		else
			BIO_puts(out,"unable to print attribute\n");
		if (++ii < count) goto get_next;
	}
	n = BIO_get_mem_data(out, &ext);
	if (n)
	{
		result = (char *) malloc (n+1);
		result [n] = '\0';
		memcpy (result, ext, n);
	}
	RETVAL = result;
	BIO_free(out);
#line 3142 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_signature_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_signature_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1683 "OpenSSL.xs"
	BIO *out;
	unsigned char *sig, *result;
	int n;
#line 3165 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1687 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	i2a_ASN1_OBJECT(out, csr->sig_alg->algorithm);
	n = BIO_get_mem_data(out, &sig);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, sig, n);
	RETVAL = result;
	BIO_free(out);
#line 3184 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "csr");
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1702 "OpenSSL.xs"
	BIO *out;
	unsigned char *sig, *result;
	int n,i;
	unsigned char *s;
#line 3208 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1707 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	n=csr->signature->length;
	s=csr->signature->data;
	for (i=0; i<n; i++)
	{
		if ( ((i%18) == 0) && (i!=0) ) BIO_printf(out,"\n");
		BIO_printf(out,"%02x%s",s[i], (((i+1)%18) == 0)?"":":");
	}
	n = BIO_get_mem_data(out, &sig);
	result = (char *) malloc (n+1);
	result [n] = '\0';
        memcpy (result, sig, n);
	RETVAL = result;
	BIO_free(out);
#line 3233 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__Misc_rand_bytes); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__Misc_rand_bytes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "bytes");
    {
	int	bytes = (int)SvIV(ST(0));
#line 1731 "OpenSSL.xs"
		unsigned char seed[20];
		unsigned char *rnd = NULL;
		char * ret = NULL;
		int i = 0;
		int count = 0;
#line 3258 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;
#line 1737 "OpenSSL.xs"
		if ( bytes <= 0 ) {
			RETVAL = NULL;
			return;
		};

        	if (!RAND_pseudo_bytes(seed, 20)) {
			RETVAL = NULL;
        	        return;
        	}
        	RAND_seed(seed, sizeof seed);


		if((rnd = (char *) malloc ( bytes )) == NULL ) {
			RETVAL = NULL;
			return;
		}

		if (!RAND_bytes(rnd, bytes)) {
			RETVAL = NULL;
			return;
		}
		if((ret = (char *) malloc (bytes * 2 + 1)) == NULL ) {
			free (rnd);
			RETVAL = NULL;
			return;
		}

		count = 0;
		for ( i = 0; i < bytes; i++ ) { 
			sprintf( &ret[count], "%2.2X", rnd[i] );
			count = count + 2;
		}
		ret[bytes*2] = '\x0';
		free ( rnd );
		RETVAL = ret;
#line 3297 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_OpenCA__OpenSSL); /* prototype to pass -Wmissing-prototypes */
XS(boot_OpenCA__OpenSSL)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("OpenCA::OpenSSL::constant", XS_OpenCA__OpenSSL_constant, file);
        newXS("OpenCA::OpenSSL::X509::_new_from_der", XS_OpenCA__OpenSSL__X509__new_from_der, file);
        newXS("OpenCA::OpenSSL::X509::_new_from_pem", XS_OpenCA__OpenSSL__X509__new_from_pem, file);
        newXS("OpenCA::OpenSSL::X509::init_oids", XS_OpenCA__OpenSSL__X509_init_oids, file);
        newXS("OpenCA::OpenSSL::X509::serial", XS_OpenCA__OpenSSL__X509_serial, file);
        newXS("OpenCA::OpenSSL::X509::hex_serial", XS_OpenCA__OpenSSL__X509_hex_serial, file);
        newXS("OpenCA::OpenSSL::X509::subject", XS_OpenCA__OpenSSL__X509_subject, file);
        newXS("OpenCA::OpenSSL::X509::openssl_subject", XS_OpenCA__OpenSSL__X509_openssl_subject, file);
        newXS("OpenCA::OpenSSL::X509::issuer", XS_OpenCA__OpenSSL__X509_issuer, file);
        newXS("OpenCA::OpenSSL::X509::notBefore", XS_OpenCA__OpenSSL__X509_notBefore, file);
        newXS("OpenCA::OpenSSL::X509::notAfter", XS_OpenCA__OpenSSL__X509_notAfter, file);
        newXS("OpenCA::OpenSSL::X509::alias", XS_OpenCA__OpenSSL__X509_alias, file);
        newXS("OpenCA::OpenSSL::X509::fingerprint", XS_OpenCA__OpenSSL__X509_fingerprint, file);
        newXS("OpenCA::OpenSSL::X509::subject_hash", XS_OpenCA__OpenSSL__X509_subject_hash, file);
        newXS("OpenCA::OpenSSL::X509::emailaddress", XS_OpenCA__OpenSSL__X509_emailaddress, file);
        newXS("OpenCA::OpenSSL::X509::version", XS_OpenCA__OpenSSL__X509_version, file);
        newXS("OpenCA::OpenSSL::X509::pubkey_algorithm", XS_OpenCA__OpenSSL__X509_pubkey_algorithm, file);
        newXS("OpenCA::OpenSSL::X509::pubkey", XS_OpenCA__OpenSSL__X509_pubkey, file);
        newXS("OpenCA::OpenSSL::X509::keysize", XS_OpenCA__OpenSSL__X509_keysize, file);
        newXS("OpenCA::OpenSSL::X509::modulus", XS_OpenCA__OpenSSL__X509_modulus, file);
        newXS("OpenCA::OpenSSL::X509::exponent", XS_OpenCA__OpenSSL__X509_exponent, file);
        newXS("OpenCA::OpenSSL::X509::extensions", XS_OpenCA__OpenSSL__X509_extensions, file);
        newXS("OpenCA::OpenSSL::X509::signature_algorithm", XS_OpenCA__OpenSSL__X509_signature_algorithm, file);
        newXS("OpenCA::OpenSSL::X509::signature", XS_OpenCA__OpenSSL__X509_signature, file);
        newXS("OpenCA::OpenSSL::CRL::_new_from_der", XS_OpenCA__OpenSSL__CRL__new_from_der, file);
        newXS("OpenCA::OpenSSL::CRL::_new_from_pem", XS_OpenCA__OpenSSL__CRL__new_from_pem, file);
        newXS("OpenCA::OpenSSL::CRL::version", XS_OpenCA__OpenSSL__CRL_version, file);
        newXS("OpenCA::OpenSSL::CRL::issuer", XS_OpenCA__OpenSSL__CRL_issuer, file);
        newXS("OpenCA::OpenSSL::CRL::issuer_hash", XS_OpenCA__OpenSSL__CRL_issuer_hash, file);
        newXS("OpenCA::OpenSSL::CRL::lastUpdate", XS_OpenCA__OpenSSL__CRL_lastUpdate, file);
        newXS("OpenCA::OpenSSL::CRL::nextUpdate", XS_OpenCA__OpenSSL__CRL_nextUpdate, file);
        newXS("OpenCA::OpenSSL::CRL::fingerprint", XS_OpenCA__OpenSSL__CRL_fingerprint, file);
        newXS("OpenCA::OpenSSL::CRL::signature_algorithm", XS_OpenCA__OpenSSL__CRL_signature_algorithm, file);
        newXS("OpenCA::OpenSSL::CRL::signature", XS_OpenCA__OpenSSL__CRL_signature, file);
        newXS("OpenCA::OpenSSL::CRL::extensions", XS_OpenCA__OpenSSL__CRL_extensions, file);
        newXS("OpenCA::OpenSSL::CRL::serial", XS_OpenCA__OpenSSL__CRL_serial, file);
        newXS("OpenCA::OpenSSL::CRL::revoked", XS_OpenCA__OpenSSL__CRL_revoked, file);
        newXS("OpenCA::OpenSSL::SPKAC::_new", XS_OpenCA__OpenSSL__SPKAC__new, file);
        newXS("OpenCA::OpenSSL::SPKAC::pubkey_algorithm", XS_OpenCA__OpenSSL__SPKAC_pubkey_algorithm, file);
        newXS("OpenCA::OpenSSL::SPKAC::pubkey", XS_OpenCA__OpenSSL__SPKAC_pubkey, file);
        newXS("OpenCA::OpenSSL::SPKAC::keysize", XS_OpenCA__OpenSSL__SPKAC_keysize, file);
        newXS("OpenCA::OpenSSL::SPKAC::modulus", XS_OpenCA__OpenSSL__SPKAC_modulus, file);
        newXS("OpenCA::OpenSSL::SPKAC::exponent", XS_OpenCA__OpenSSL__SPKAC_exponent, file);
        newXS("OpenCA::OpenSSL::SPKAC::signature_algorithm", XS_OpenCA__OpenSSL__SPKAC_signature_algorithm, file);
        newXS("OpenCA::OpenSSL::SPKAC::signature", XS_OpenCA__OpenSSL__SPKAC_signature, file);
        newXS("OpenCA::OpenSSL::PKCS10::_new_from_der", XS_OpenCA__OpenSSL__PKCS10__new_from_der, file);
        newXS("OpenCA::OpenSSL::PKCS10::_new_from_pem", XS_OpenCA__OpenSSL__PKCS10__new_from_pem, file);
        newXS("OpenCA::OpenSSL::PKCS10::version", XS_OpenCA__OpenSSL__PKCS10_version, file);
        newXS("OpenCA::OpenSSL::PKCS10::subject", XS_OpenCA__OpenSSL__PKCS10_subject, file);
        newXS("OpenCA::OpenSSL::PKCS10::subject_hash", XS_OpenCA__OpenSSL__PKCS10_subject_hash, file);
        newXS("OpenCA::OpenSSL::PKCS10::fingerprint", XS_OpenCA__OpenSSL__PKCS10_fingerprint, file);
        newXS("OpenCA::OpenSSL::PKCS10::emailaddress", XS_OpenCA__OpenSSL__PKCS10_emailaddress, file);
        newXS("OpenCA::OpenSSL::PKCS10::pubkey_algorithm", XS_OpenCA__OpenSSL__PKCS10_pubkey_algorithm, file);
        newXS("OpenCA::OpenSSL::PKCS10::pubkey", XS_OpenCA__OpenSSL__PKCS10_pubkey, file);
        newXS("OpenCA::OpenSSL::PKCS10::keysize", XS_OpenCA__OpenSSL__PKCS10_keysize, file);
        newXS("OpenCA::OpenSSL::PKCS10::modulus", XS_OpenCA__OpenSSL__PKCS10_modulus, file);
        newXS("OpenCA::OpenSSL::PKCS10::exponent", XS_OpenCA__OpenSSL__PKCS10_exponent, file);
        newXS("OpenCA::OpenSSL::PKCS10::extensions", XS_OpenCA__OpenSSL__PKCS10_extensions, file);
        newXS("OpenCA::OpenSSL::PKCS10::attributes", XS_OpenCA__OpenSSL__PKCS10_attributes, file);
        newXS("OpenCA::OpenSSL::PKCS10::signature_algorithm", XS_OpenCA__OpenSSL__PKCS10_signature_algorithm, file);
        newXS("OpenCA::OpenSSL::PKCS10::signature", XS_OpenCA__OpenSSL__PKCS10_signature, file);
        newXS("OpenCA::OpenSSL::Misc::rand_bytes", XS_OpenCA__OpenSSL__Misc_rand_bytes, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

